package ;

import openfl.Assets;
import flash.display.Bitmap;
import flash.display.BitmapData;
import flash.display.Sprite;
import flash.errors.Error;
import flash.events.Event;
import flash.Lib;
import flash.text.TextField;
import flash.text.TextFieldAutoSize;
import flixel.FlxG;
import flixel.FlxState;

class MenuState extends FlxState 
{
	var m_optionsYOffset:Int=0;
	var m_background:Bitmap;
	var m_options:TextField;
	var m_floatyCounter:Float = 0;
	
	public function new()
	{
		super();
	}
	
	override public function create():Void
	{
		super.create();
		FlxG.mouse.useSystemCursor = true;
		m_background = new Bitmap(Assets.getBitmapData("assets/titlescreen.png"));
		Lib.current.stage.addChild(m_background);
		m_options = GameClass.m_instance.CreateTextField();
		m_options.wordWrap = false;
		m_options.text = "Click to start";
		m_options.autoSize = TextFieldAutoSize.LEFT;
		m_options.background = false;
		m_options.textColor = 0xffffff;
		m_options.mouseEnabled = false;
		Lib.current.stage.addChild(m_options);
		OnResize(null);
	}
	
	override public function destroy():Void
	{
		Lib.current.stage.removeChild(m_options);
		m_options = null;
		Lib.current.stage.removeChild(m_background);
		m_background = null;
		super.destroy();
	}
	
	function OnResize(e:Event):Void
	{
		//m_background.scaleX = m_background.scaleY = GameClass.m_instance.GetScale();
		m_options.x = Lib.current.stage.stageWidth - m_options.width - 10;
		m_options.y = m_optionsYOffset=Std.int(Lib.current.stage.stageHeight-m_options.height-10);
	}
	
	override public function update():Void
	{
		//check input
		if (FlxG.mouse.justPressed)
		{
			FlxG.switchState(new PlayState());
		}
		//move text
		m_options.y = m_optionsYOffset+(Math.sin(m_floatyCounter)*5);
		m_floatyCounter += 0.1;
		if (m_floatyCounter >= 314)//pi
		{
			m_floatyCounter = 0;
			m_options.y = m_optionsYOffset;
		}
	}
	
}