package ;

import openfl.Assets;
import flash.display.Bitmap;
import flash.display.BitmapData;
import flash.display.Sprite;
import flash.errors.Error;
import flash.events.Event;
import flash.Lib;
import flash.text.TextField;
import flash.text.TextFieldAutoSize;
import flixel.FlxG;
import flixel.FlxState;

class SparetimeState extends FlxState 
{
	var m_optionsYOffset:Int = 0;
	var m_floatyCounter:Float = 0;
	var m_options:TextField;
	var m_message:TextField;
	//var m_choices:Array<String>;
	var m_selection:Int = 0;
	var m_avgLineHeight:Float = 0;
	var m_arrow:TextField;
	
	public function new(msg:String="School is over for today, \nwhat do you want to do?")
	{
		super();
		//m_choices = ["play a game", "do sports", "lie in the grass", "do homework", "go shopping", "watch a movie", "look at cars", "listen to music", "learn a recipe/cook something", "go to art gallery"];
		var text:String = msg+"\n";
		for (c in GameClass.m_instance.m_things)
		{
			text += "\n\t" + c;
		}
		m_message = GameClass.m_instance.CreateTextField();
		m_message.text = text;
	}
	
	override public function create():Void
	{
		super.create();
		FlxG.mouse.useSystemCursor = true;
		
		m_message.width = FlxG.stage.stageWidth;
		m_message.height = FlxG.stage.stageHeight;
		m_message.wordWrap = false;
		m_message.autoSize = TextFieldAutoSize.LEFT;
		m_message.background = false;
		m_message.textColor = 0xffffff;
		m_message.mouseEnabled = false;
		Lib.current.stage.addChild(m_message);
		m_avgLineHeight=m_message.textHeight / m_message.numLines;
		/*m_options = GameClass.m_instance.CreateTextField();
		m_options.wordWrap = false;
		m_options.text = "Press Enter to continue";
		m_options.autoSize = TextFieldAutoSize.LEFT;
		m_options.background = false;
		m_options.textColor = 0xffffff;
		m_options.mouseEnabled = false;
		Lib.current.stage.addChild(m_options);*/
		m_arrow = GameClass.m_instance.CreateTextField();
		m_arrow.text = ">";
		m_arrow.autoSize = TextFieldAutoSize.LEFT;
		m_arrow.background = false;
		m_arrow.textColor = 0xffffff;
		m_arrow.mouseEnabled = false;
		Lib.current.stage.addChild(m_arrow);
		OnResize(null);
	}
	
	override public function destroy():Void
	{
		Lib.current.stage.removeChild(m_arrow);
		m_arrow = null;
		Lib.current.stage.removeChild(m_message);
		m_message = null;
		super.destroy();
	}
	
	function OnResize(e:Event):Void
	{
		m_arrow.x = 0;
		m_message.x = 0;
		m_message.y = 0;
		//m_options.x = Lib.current.stage.stageWidth - m_options.width - 10;
		//m_options.y = m_optionsYOffset=Std.int(Lib.current.stage.stageHeight-m_options.height-10);
	}
	
	override public function update():Void
	{
		//check input
		if (FlxG.keys.justPressed.UP)
		{
			if (m_selection>0) m_selection--;
		}
		if (FlxG.keys.justPressed.DOWN)
		{
			if (m_selection < GameClass.m_instance.m_things.length - 1) m_selection++;
		}
		var index:Int = 1;
		for (i in 0...m_message.numLines)
		{
			if (m_message.getLineText(i) == "\n")
			{
				index = i;
				break;
			}
		}
		m_arrow.y = (m_selection + index+1) * m_avgLineHeight;
		if (FlxG.keys.justPressed.SPACE)
		{
			//calc results
			var thing:String = GameClass.m_instance.m_things[m_selection];
			var result:String = "You liked " + thing + " a little better.\n";
			if (thing == "do sports") result += "You also got stronger.\n";
			GameClass.m_instance.m_playerStats.DidThing(thing, true);
			for (stats in GameClass.m_instance.m_invitations)
			{
				var stance:Float = stats.DidThing(thing);
				if (stance < -0.5) result += stats.m_name + " hated you for it.\n";
				else if (stance < 0) result += stats.m_name + " didn't like it (and liked you less).\n";
				else if (stance > 0.5) result += stats.m_name + " had a great time BFF!\n";
				else if (stance >= 0) result += stats.m_name + " was ok with your choice.\n";
			}
			FlxG.switchState(new TextState(result,new PlayState()));
		}
		//move text
		/*m_options.y = m_optionsYOffset+(Math.sin(m_floatyCounter)*5);
		m_floatyCounter += 0.1;
		if (m_floatyCounter >= 314)//pi
		{
			m_floatyCounter = 0;
			m_options.y = m_optionsYOffset;
		}*/
	}
	
}